/*
 * PM - 2016
 * lab0.c
 */

#include <avr/interrupt.h>
#include <avr/io.h>

#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		3
#define MORSE_SCURT		1

#define NUM_NOTE		8
#define DURATA_NOTA		100

uint16_t durations[] = {500, 500, 500, 350, 150, 500, 350, 150, 650, 500, 500, 500, 350, 150, 500, 350, 150, 650, 500, 300, 150, 400, 200, 200, 125, 125, 250, 250, 400, 200, 200, 125, 125, 250, 125, 500, 375, 125, 500, 375, 125, 650, 500, 300, 150, 400, 200, 200, 125, 125, 250, 250, 400, 200, 200, 125, 125, 250, 250, 500, 375, 125, 500, 375, 125, 650};

volatile int got_echo = 0;
volatile int note = -1;
volatile int played = 1;
volatile int distance = 0;
volatile uint8_t note_remaining = 1;
int tones[] = { 261, 277, 294, 311, 330, 349, 370, 392 };
uint8_t num_notes = sizeof(tones) / sizeof(tones[0]);
int8_t note_position = 0;

void update_note(int note_position)
{
	if(--note_remaining == 0)
    {
		note_remaining = durations[note_position] / 30;
		uint16_t new_top = 16000000 / 1024 / 2 / tones[note_position];
		TCNT1 = 0;
		OCR1B = (uint32_t)new_top * OCR1B / OCR1A;
		OCR1A = new_top;
	}
}

/* intreruperea de comparatie cu OCR1A */
ISR(TIMER1_COMPA_vect)
{
	PORTD &=  ~(1 << PD7);
}


ISR(PCINT1_vect)
{
    if (got_echo == 0) {
		TCCR0B |= (1 << CS01);
		//PORTD &=  ~(1 << PD5);
		PORTD &=  ~(1 << PD7);
		got_echo = 1;
	} else {
	// Disable counter 
		TCCR0B = 0;
		distance = TCNT0 / (53 * 2);
		TCNT0 = 0;

		if (distance - note > 0) {
			PORTD |=  (1 << PD7);
			note = distance;
			if (note_position < num_notes - 1) {
				note_position = (note_position + 1) % num_notes;
				update_note(note_position);
			}
		} else if (note - distance > 0) {
			PORTD |=  (1 << PD7);
			note = distance;
			if (note_position > 0)
				note_position = (note_position - 1) % num_notes;
			update_note(note_position);
		} else {
			PORTD &=  ~(1 << PD5);
		}
		got_echo = 0;
	}
}

void IO_init()
{
    /* trigger pin */
	DDRB |= (1 << PB0);
	PORTB &= ~(1 << PB0);
	
	/* echo pin */
	DDRB &= ~(1 << PB1);
	PORTB |= (1 << PB1);
	
	/* Setez pinul PD7 = led placa ca iesire. */
	DDRD |= (1 << PD7);
	/* Sting LED-ul. */
	PORTD &= ~(1 << PD7);
	DDRD |= (1 << PD5);
	//PORTD &= ~(1 << PD5);
    
    // intreruperile sunt activate pentru PCINT8 (PB0) si PCINT9 (PB1)
    PCICR  = (1 << PCIE1);
    PCMSK1 = (1 << PCINT9);
}



/* initializeaza timer-ul 1 pentru exercitiile 1-4 */
void timer1_init_ex1_4()
{
	TCCR1A |= (1 << COM1A0) | (1 << COM1B0);
    TCCR1B = (5 << CS10) | (1 << WGM12);
	OCR1B = 0;
    OCR1A = 0;
}



void task1(void) {


	sei();
    IO_init();
	timer1_init_ex1_4();

	while(1) {
		PORTB |= (1 << PB0);
		_delay_us(10);
		PORTB &= ~(1 << PB0);
		_delay_ms(25);		
	}
}

int main(void) {
	task1();

	return 0;
}
